(
var genInitSeq, finalizeSeqs, finalizeAccompHigh, finalizeAccompLow;

//~~~~init vars for initial sequence generation
genInitSeq = {arg seed = 20200525;
	var setDur, strings, stringIndex, state, lastStrings, position, dur, openStringCount, landingCount, sectionCount, model, res;

	thisThread.randSeed = seed;

	//~~~~helper dur function
	setDur = {[0, 2, 3, 4, 5.rand + 3].wchoose([0, 5, 5, 5, 1].normalizeSum)};

	strings = (0..5);
	state = 6.collect({[0, 1].wchoose([2, 1].normalizeSum)}); //fretted or not
	lastStrings = [nil, nil];
	position = 6.collect({10 + 3.rand}); //which frets
	dur = setDur.value;
	openStringCount = 0;
	landingCount = 0; //for extending section landing on open strings
	sectionCount = 0;


	model = 20.collect({
		[
			//probabily adjustment for altering picking pattern
			2 + 1.0.rand2,
			//probabilities adjustment for altering state
			2 + 1.0.rand2,
			//probabilities adjustment for position
			7 + 2.0.rand2,
			//probabilities for inserting walk down
			2 + 1.0.rand2
		]
	});

	res = []; //notes before the more static repetitions are put in

	//~~~~run routine and create template sequence
	({sectionCount < 20}).while({
		var alterPattern;

		//alter string pattern or not
		alterPattern = [true, false].wchoose([1, model[sectionCount][0]].normalizeSum);
		if(alterPattern, {
			strings = (0..5).scramble[..(4.rand + 1)];
			//rotate if a note gets repeated
			if(lastStrings.last == strings.first, {strings = strings.rotate});
			lastStrings = strings;
		});

		//iterate through the strings
		strings.do({arg string, stringIndex;
			var alterPos;

			//alter state or not favoring off if on (determines if string is open or fretted)
			if(sectionCount.even, {
				var isFretted, probs, alterState;
				isFretted = (state[string] == 1);
				probs = [if(isFretted, {model[sectionCount][1]}, {1}), 1].normalizeSum;
				alterState = [true, false].wchoose(probs);
				if(alterState, {state[string] = (state[string] + 1) % 2});
			});

			//alternate option
			if(sectionCount.odd, {
				var isFretted, alterable;
				isFretted = (state[string] == 1);
				alterable = isFretted || ((state[string] == 0) && (state.sum < 3));
				if(alterable, {
					var probs, alterState;
					probs = [if(isFretted, {1}, {model[sectionCount][1]}), 1].normalizeSum;
					alterState = [true, false].wchoose(probs);
					if(alterState, {state[string] = (state[string] + 1) % 2});
				});
			});

			//alter fret if fretted and keeping hand in similar position
			alterPos = (position[string] * state[string]) > 0;
			alterPos = alterPos && (state[string] == 1); //isFretted
			alterPos = alterPos && (position[string] > (position.maxItem - 3));
			alterPos = [alterPos, false].wchoose([model[sectionCount][2], 1].normalizeSum);
			if(alterPos, {
				var walkDown, stepLimit;
				//walk down or not
				walkDown = [true, false].wchoose([1, model[sectionCount][3]].normalizeSum);
				if(walkDown, {
					res = res.add([string, state[string] * position[string], dur, position.deepCopy]);
				});

				//make sure a hand position is not too wide
				stepLimit = (position.maxItem - (position[string] - 2)) != 4;
				if(stepLimit.not, {
					position[string] = (position[string] - 1).clip(0, 12);
				});
				if(stepLimit, {
					position[string] = (position[string] - [1, 2].choose).clip(0, 12);
				});
			});

			//alter duration or not
			if([true, false].wchoose([3, 1].normalizeSum), {dur = setDur.value});

			//add
			res = res.add([string, state[string] * position[string], dur, position.deepCopy]);

			//reset if everything arrives at the bottom string
			//perhaps erase the extranotes here!
			if((position[string] * state[string]) == 0, {openStringCount = openStringCount + 1}, {openStringCount = 0});
			if(position == [0, 0, 0, 0, 0, 0], {
				var hasLanded;
				hasLanded = (openStringCount > 20) && (stringIndex == (strings.size - 1));
				if(hasLanded, {
					position = 6.collect({10 + 3.rand});
					landingCount = 0;
					sectionCount = sectionCount + 1;
					(openStringCount - 1).do({arg index;
						res[res.size - index - 1][3] = [0, 0, 0, 0, 0, 0];
						res[res.size - index - 1][2] = (dur * (1 + ((1 - (index / openStringCount).clip(0, 1).pow(0.25)) * 10))).asInteger
					});
				});
				if(hasLanded.not, {landingCount = landingCount + 1})
			});
		})
	});
	res
};


//~~~~insert more static sections by repeating a figure
finalizeSeqs = {arg initSeq;
	var extendToBeat, insertTS,
	timeStampSection, timeStampTotal, timeStampSectionStart, lastDur, lastPos,
	sectionSeq, timeSigInsSeq, sectionPosLimit, state, guitarSeq;

	extendToBeat = {arg seq, round = 4;
		var timeStampTotal, altEndDur;
		// this makes sure it is some multiple of a beat
		timeStampTotal = seq.slice(nil, 2).sum;
		altEndDur = timeStampTotal.round(round) - timeStampTotal;
		seq.last[2] = seq.last[2] + altEndDur;
		if(altEndDur < 0, {seq.last[2]});
		[seq, altEndDur];
	};

	insertTS = {arg seq, timeStampSectionStart, type, accompSwitch;
		var timeStampTotal, noMeasures;
		timeStampTotal = seq.slice(nil, 2).sum;
		sectionSeq = sectionSeq.add([timeStampTotal, type, accompSwitch]);
		noMeasures = ((timeStampTotal - timeStampSectionStart) / 16);
		if(noMeasures.frac > 0, {
			timeSigInsSeq = timeSigInsSeq.add(
				// make 3/2 instrad of 1/2
				if((noMeasures.frac / 0.25).asInteger != 2, {
					[timeStampTotal - (4 * (noMeasures.frac / 0.25).asInteger),(noMeasures.frac / 0.25).asInteger]
				}, {
					[timeStampTotal - (4 * 6), 6]
				});
			);
			timeSigInsSeq = timeSigInsSeq.add([timeStampTotal, 4]);
		});
	};

	timeStampSection = 0; //track time in each section
	timeStampTotal = 0; //track overall time
	timeStampSectionStart = 0; //track the time of the start of a section
	lastDur = initSeq[0][2]; //helper for time signature data
	lastPos = initSeq[0].last; //helper for keeping track of landing.

	guitarSeq = []; //this is the final sequence with repetitions inserted
	sectionSeq = [[0, 0, true]]; //sequence of times for each section (used for double bars in score)
	timeSigInsSeq = [[0, 4]]; //sequence for insertion of time signatures and double bars;

	sectionPosLimit = 3 + 6.rand;
	state = 0;

	initSeq.do({arg item, index, altEndDur;
		var dur, pos;
		dur = item[2];
		pos = item.last;

		if(state != 1, {
			// basically this just copies the original template over
			var landingBorder, sectionBorder;
			landingBorder = (pos == [0, 0, 0, 0, 0, 0]) && (lastPos != [0, 0, 0, 0, 0, 0]);
			sectionBorder = (pos != [0, 0, 0, 0, 0, 0]) && (lastPos == [0, 0, 0, 0, 0, 0]);
			if(landingBorder || sectionBorder, {
				var seqExtPair;
				seqExtPair = extendToBeat.value(guitarSeq, 8);
				guitarSeq = seqExtPair[0];
				timeStampSection = timeStampSection + seqExtPair[1];
				insertTS.value(guitarSeq, timeStampSectionStart, if(pos == [0, 0, 0, 0, 0, 0], {1}, {-1}), false);
				timeStampSectionStart = guitarSeq.slice(nil, 2).sum;
			});

			if(sectionBorder, {
				state = 0;
				sectionPosLimit = 3 + 6.rand;
			});

			guitarSeq = guitarSeq.add(item.add(-1));
			timeStampSection = timeStampSection + dur;

			lastDur = dur;
			lastPos = pos;

			if((state == 0) && (pos.minItem < sectionPosLimit), {state = 1});
		});

		if(state == 1, {
			// grabs a figure and repeats it altering it subtly
			var rec, reps, noMeasures;

			guitarSeq = extendToBeat.value(guitarSeq, 8)[0];
			timeStampTotal = guitarSeq.slice(nil, 2).sum;
			insertTS.value(guitarSeq, timeStampSectionStart, 0, true);
			timeStampSectionStart = timeStampTotal;
			rec = guitarSeq[(guitarSeq.size - (10.rand + 5))..guitarSeq.size].deepCopy;
			reps = 5.rand + 5;
			reps.do({arg index;
				rec.do({arg item, rIndex;
					var add, dur;
					add = if(index == 0, {3}, {0});
					dur = (item[2] + 2.rand2 + add);
					if(dur < 2, {dur = [0, 2].wchoose([1, 4].normalizeSum)});
					rec[rIndex] = [item[0], item[1], dur];
					if([true, false].wchoose([5, 1].normalizeSum), {
						guitarSeq = guitarSeq.add(rec[rIndex].add((1 / reps) * index));
					});

					// if chord randomly choose one of the notes
					if(guitarSeq.last[2] == 0, {
						arg toAdd = [];
						toAdd = toAdd.add(guitarSeq.pop);
						toAdd = toAdd.add(guitarSeq.pop);
						toAdd[0][2] = toAdd[1][2];
						toAdd[1][3] = toAdd[0][3];
						toAdd = toAdd.choose;
						guitarSeq = guitarSeq.add(toAdd);
					});
				});

				if(index < (reps - 1), {
					guitarSeq = extendToBeat.value(guitarSeq, 4)[0];
				}, {
					guitarSeq = extendToBeat.value(guitarSeq, 8)[0];
				});

			});

			insertTS.value(guitarSeq, timeStampSectionStart, 0, true);

			timeStampSection = 0;
			timeStampSectionStart = guitarSeq.slice(nil, 2).sum;
			lastDur = initSeq[index + 1][2];
			state = 2;
		});
	});
	[guitarSeq, sectionSeq, timeSigInsSeq]
};

// add the high note part
// ??? Perhaps make tultimate subsections only long ???
finalizeAccompHigh = {arg sectionSeq;
	var accompHighSeq, timeStamp, secType;
	accompHighSeq = [];
	timeStamp = 0;
	secType = 0;

	sectionSeq.do({arg secData, secIndex;
		var secEnd, freq, noRestCount, shortCount;
		secEnd = secData[0];
		//freq = if(secType == 0, {62.midicps * 8},  {62.midicps * 8 * 6/5});
		freq = if(secIndex.even, {62.midicps * 8},  {62.midicps * 8 * 6/5});
		if(secData.last, {secType = ((secType + 1) % 2)});
		noRestCount = 0;
		shortCount = 0;
		while({timeStamp < secEnd}, {
			var dur, sus, isShort, insertRest;

			isShort = case
			{shortCount == 0} {true}
			{shortCount < 3} {[true, false].wchoose([3, 1].normalizeSum)}
			{true} {false};

			insertRest = [true, noRestCount > 3].wchoose([2, 1].normalizeSum);

			if(isShort, {
				sus = (10.rand + 10).round(2);
				shortCount = shortCount + 1;
			}, {
				sus = (30.rand + 30).round(2);
				shortCount = 0;
			});

			if(insertRest, {
				dur = sus + (20.rand + 10).round(2);
				noRestCount = 0;
			}, {
				dur = sus + 2;
				noRestCount = noRestCount + 1;
			});

			if((timeStamp + dur) < secEnd, {
				accompHighSeq = accompHighSeq.add([freq, dur, sus.clip(0, dur)]);
			}, {
				//dur = ((secEnd - timeStamp) + 38.rand).clip(2, 1000).round(2);
				//accompHighSeq = accompHighSeq.add([freq, dur, 0]);
				var remainder;
				remainder = (secEnd - timeStamp);
				sus = if(remainder > 10, {((remainder - 10).rand + 8).round(2)}, {0});
				dur = (remainder + 10.rand).clip(2, 1000).round(2);
				accompHighSeq = accompHighSeq.add([freq, dur, sus]);
			});
			timeStamp = timeStamp + dur;
		});
	});
	accompHighSeq
};


// add the low note part
finalizeAccompLow = {arg guitarSeq, sectionSeq;
	var accompLowSeq, durAccum, lastTrigVal;
	accompLowSeq = [];
	durAccum = 0;
	lastTrigVal = 0;
	guitarSeq.do({arg item, i;
		var dur, trig, freq1, freq2, finalDur;
		dur = item[2];
		trig = item.last;
		if(lastTrigVal != trig, {
			freq1 = if(trig > -1, {62.midicps / 4 * 3/4}, {62.midicps / 4});
			freq2 = freq1 + if(trig > -1, {(5 * (1-trig))}, {0});
			finalDur = durAccum;
			accompLowSeq = accompLowSeq.add([freq1, freq2, finalDur]);
			durAccum = 0;
		});
		durAccum = durAccum + dur;
		lastTrigVal = trig;
	});

	accompLowSeq = [accompLowSeq.slice(nil, 0), accompLowSeq.slice(nil, 1), accompLowSeq.slice(nil, 2).integrate].flop;
	sectionSeq.collect({arg section;
		if(section[1] == 1, {
			var curTime = section[0];
			accompLowSeq = accompLowSeq.add([62.midicps / 8, (62.midicps / 8) + 0, curTime]);
			curTime = curTime - (50.rand + 50).round(4).asInteger;
			accompLowSeq = accompLowSeq.add([64.midicps / 8, (64.midicps / 8) + 2, curTime]);
			curTime = curTime - (50.rand + 50).round(4).asInteger;
			accompLowSeq = accompLowSeq.add([65.midicps / 8, (65.midicps / 8) + 4, curTime]);
		});
		if(section[1] == -1, {
			var curTime = section[0];
			accompLowSeq = accompLowSeq.add([62.midicps / 4, (62.midicps / 4) + 0, curTime]);
		});
	});

	accompLowSeq = accompLowSeq.sort({ arg a, b; a[2] < b[2] });
	accompLowSeq = [accompLowSeq.slice(nil, 0), accompLowSeq.slice(nil, 1),
		accompLowSeq.slice(nil, 2).differentiate.drop(1).add(1)].flop;

	accompLowSeq
};

~genMusicData = {
	var initSeq, finalSeqs, guitarSeq, accompHighSeq, accompLowSeq, sectionSeq, timeSigSeq,
	patterns, scoreData, sectionOffsets;

	initSeq = genInitSeq.value;
	finalSeqs = finalizeSeqs.value(initSeq);
	guitarSeq = finalSeqs[0];
	accompHighSeq = finalizeAccompHigh.value(finalSeqs[1].deepCopy.add([finalSeqs[0].slice(nil, 2).sum, -1, false]));
	accompLowSeq = finalizeAccompLow.value(finalSeqs[0], finalSeqs[1]);
	sectionSeq = finalSeqs[1];
	timeSigSeq = finalSeqs[2];

	patterns = ~genPatterns.value(guitarSeq, accompLowSeq, accompHighSeq, sectionSeq);
	scoreData =  ~genScoreData.value(guitarSeq, accompLowSeq, accompHighSeq, timeSigSeq, sectionSeq);
	sectionOffsets = sectionSeq.slice(nil, 0);

	[patterns, scoreData, sectionOffsets]
};
)